(function(window, undefined) {
  window.iw = {

    logleveltable : ["error", "warn", "info", "debug", "trace"],
    
    logginglevel  : 1, 

    logging       : true,
    
    log: function(message, level) {        
      if(iw.logging && window.console) {  //only if if console is defined
        if(level === undefined) level = 2 //info
        if(level <= iw.logginglevel) {
          //console.log("["+iw.logleveltable[level]+"] " + message);
          if(level == 0) console.error(message);
          if(level == 1) console.warn(message);
          if(level == 2) console.info(message);
          if(level == 3) console.debug(message);
          if(level == 4) console.debug(message);
        }
        
      }
    },
    uuidv4 : function() {      
      return ([1e7]+1e3+4e3+8e3+1e11).replace(/[018]/g, c =>
        (c ^ crypto.getRandomValues(new Uint8Array(1))[0] & 15 >> c / 4).toString(16)
      )
    },
    
    /**
		* @input s:  string
		* @input a:  string array
		* @returns : longest common string
		*/
		findLongestCommonString : function (s, a) {
		   iw.log("[find LCS]: start", 3);
		   
         //only evaluate if both s and a are defined and a has at least one element
		   if(!s ||!a || a.length === 0 ) {
		      iw.log("[find LCS]: returning, input doesn't qualify", 4);
		      return s;
		   } 
		   
		   //only evaluate if s is a substring of the first element of a		   
		   if(a[0].indexOf(s) < 0) {
		      iw.log("string is not a substring of " + a[0], 4);
		      return s;
		   }
		   
		   var start = a[0].toLowerCase().indexOf(s.toLowerCase());
		   var sl    = s.length;
		   var ts    = s;

		   iw.log("start: "+start+" ts: " + ts + "; sl: " + sl, 4);
		   while(start >= 0 && start + sl < a[0].length) {  //limit loop to the length of the first array element
		      sl++;
		      iw.log("start: " + start + "; length: "+ sl, 4);
		      ts = a[0].substr(start, sl);
		      iw.log("next substring: " + ts, 4);
		      tmpA = a.filter(function(el){
		            return el.toLowerCase().includes(ts.toLowerCase());
		      });
		        
		      if(tmpA.length !== a.length) {
		      
		          ts = ts.substr(0, ts.length - 1);
		          iw.log("returning one character less. ts: " + ts, 4);
		          break;
		      }
		   
		   }
		   return ts;
		},
    
    parseContentType : function(contentType) {
      if(contentType == undefined) 
        return {}
      let parts = contentType.split(";").map(a => {return a.trim()});
      let type = parts[0];
      let result = {"type": parts[0]}
      if(parts.shift() !== undefined) {
        parts.map(a => {  
          let pt = a.split("=");
          result[pt[0]] = pt[1];
        });
      }
      return result;
    
    },
   
   invoke : function(service, data, onSuccess, onError) {
      var payload = {};
      if (data !== undefined) {
        payload = JSON.stringify(data);
      }
    
      try {
        var xhr = new XMLHttpRequest();
        xhr.open("POST", "/invoke/" + service.replace(":","/"));
        xhr.setRequestHeader('Content-Type', 'application/json');
        xhr.setRequestHeader('Accept'      , 'application/json');
        //console.log("Posting to the IS");

        xhr.onreadystatechange = function() {
          //console.log("state: " + xhr.readyState);
          if(xhr.readyState == 4 ) {
            if(xhr.status == 200) {
              let contentType = iw.parseContentType(xhr.getResponseHeader('Content-Type'));
              
              if(contentType.type === 'application/json') {  
                onSuccess(JSON.parse(xhr.response), contentType);
              }  else {
                //pass the raw response, along with the content-type
                onSuccess(xhr.response, contentType)
              }
            } else if (onError !== undefined){    
              var msg = xhr.response;
              try {
                var errorResponse = JSON.parse(xhr.response);
                            
                if(errorResponse.$error) {
                  msg = errorResponse.$errorType + ": " + errorResponse.$error;
                } 
              } catch (exception){
                  //Apparently no JSON in the response. Ignore the exception
              }
              onError(msg);
            }
          }
        }
         xhr.onerror = function(arg, msg) {
            iw.log("XHR Error:");
            iw.log(JSON.stringify(arg), 0);
            iw.log(JSON.stringify(xhr), 0);
            onError(msg);
         };
       
         xhr.upload.onerror = function(arg, msg) {
            iw.log("XHR Upload Error:");
            iw.log(arg);
            iw.log(xhr);
            iw.success = false;
            onError("Not connected anymore...")
         };
       
         xhr.onabort = function(arg) {
            iw.log("XHR Abort:");
            iw.log(arg);
            onError("Aborted");
         };
   
        xhr.send(payload);
      } catch(exception) {
          iw.log(exception, 0);
      }        
    },        
  
    listAliases: function() {
         iw.invoke("iw.test.alias:list", {}, function(data) {
            iw.availableAliases = data.aliases;
            if(data.aliases.length === 0 ) {
               //iw.availableAliases.push("(local)");              
            }                               
         });
    }  
  }
  
  Vue.component('iw-menu' , {

    template: `
      <div style="border: 3px solid green; border-radius: 4px;">
      <p class="main-header">
        <a href="testsuites.html"  v-bind:class="{'menu-active' : item === 'testsuites'}" >Test Suites</a>
        <a href="results.html"     v-bind:class="{'menu-active' : item === 'results'}"    >Results</a>
        <a href="record.html"      v-bind:class="{'menu-active' : item === 'record'}"     >Record</a>            
        <a href="config.html"      v-bind:class="{'menu-active' : item === 'config'}"     >Configuration</a>
        <a href="logs.html"        v-bind:class="{'menu-active' : item === 'logs'}"       >Logs</a>
        <a href="index.html"       v-bind:class="{'menu-active' : item === 'docs'}"       >Docs</a>                  
      </p>
      </div>
      `,
      props: ['item'],
  });

  Vue.component('select-service' , {

    template: `
      <div class="container">        
      
        <div class="row" v-if="aliasChangeable && availableAliases.length > 0" >
          <div class="column1">Remote server:</div>
          <div class="column2">
            <select v-model="alias" v-on:change="listPackages(alias)">
              <option disabled value="">Select an alias</option>
              <option></option>
              <option v-for="serverAlias in availableAliases">{{serverAlias}}</option>
           </select>                                          
          </div>
        </div>
        
        <!--div class="row" v-else-if="alias">
          <div class="column1">Remote server:</div>
          <div class="column2">{{alias}}</div>            
        </div -->
        
        <div class="row">
          <div class="column1">Package (optional):</div>
          <div class="column2">
            <select id="package-select"  v-bind:value="packageName" v-on:change="handlePackageChange($event)">
              <option></option>
              <option v-for="p in packages">{{p.name}}</option>
            </select>
          </div>
        </div>
      
        <div class="row">
          <div class="column1">Service:</div>
          <div class="column2">
            
            <input  v-bind:value="serviceName" v-on:keyup="handleServiceNameChange($event)" type="text" placeholder="type service name"></input>
            <textarea v-show="filteredServices.length > 0 && !selected"
                      id="service-list-area" 
                      readonly 
                      v-bind:value="servicesText" 
                      v-bind:rows="filteredServices.length > 20 ? 20 : filteredServices.length" 
                      v-on:click="selectService"></textarea>
          </div>
        </div>                       
    
      </div>    
    `,
  
    props: ['initialAlias', 'initialPackages', 'initialServiceName', 'initialPackageName', 'aliasChangeable','availableAliases'],
  
    data : function() {
      return {
        alias:       this.initialAlias,
        packages:    this.initialPackages,
        serviceName: this.initialServiceName,
        packageName: this.initialPackageName,
        services: [],
        filteredServices : [],
        servicesText: "",
        selected: true
      }
    },
  
    methods: {
    
      setPackages : function(data) {
        iw.log("Retrieved packages", 3);

         this.packages = data.packages.filter(function(a) {                 
               iw.log("Filter packages: " + a.name, 3);
               return a["system-package"] !== "true" && a.enabled === "true";                 
             }).sort(function(a,b){ if(a.name >= b.name) return 1; else return -1});
      },
      
      
      listPackages : function (alias) {
        
        var params = {"$alias": alias};
        
        let rp = [];
        
        iw.invoke("iw.test.ui.ns:listPackages", params, this.setPackages); 
      
      },
    	serviceComparator : function(a, b) {
		    return a.nsname > b.nsname ? 1 : (b.nsname > a.nsname ? -1 : 0);
		  },
		  
      setServices : function(data) {
        this.services = data.services.sort(this.serviceComparator);
        iw.log("-- Retrieved services", 3);
        iw.log(this.services, 4);
        this.filteredServices = this.services;
        this.servicesText = this.filteredServices.map(function(s){return s.nsname}).join("\n");
        if(this.servicesText.length == 0) {
           this.servicesText = "<no matching services>";
        }      
      },
      
      retrieveServices : function(pkg, namePart) {
        let params = {"package": pkg, "serviceNamePart": namePart, "$alias" : this.alias};
        iw.invoke("iw.test.ui.ns:listServices", params , this.setServices, this.error);		       
      },
      
      handlePackageChange : function(event) {
        iw.log("-- Handling package change. Retrieving services for " + event.target.value, 3);
        //get hold of the newly selected package
        let pkg = event.target.value;
        this.selected = false;
        //Reset the service name
        this.serviceName = "";
        this.$emit('service-deselected');
        this.retrieveServices(pkg);
        this.packageName = pkg;
      },
      		
		  handleServiceNameChange : function(event) {
		    this.serviceName = event.target.value;
		    iw.log("Service name changed: " + this.serviceName, 3);  
		    iw.log(event,3);
		    this.selected = false;
		    this.$emit('service-deselected');
		    /*
		    - If there is no package selected, and the length of the service name part == 2, then and 
		      only then query the IS.
		      In all other cases, filter the list of services.
		    */
		    if(!this.packageName && this.serviceName && this.serviceName.length <= 2) {
		      if(this.serviceName.length == 2) {  
            iw.log("Service Name length == 2 and no package selected: retrieving services from IS", 3);
            this.retrieveServices(null, this.serviceName);
		      } else {
		        //clear the list of services and filtered services
		        this.services = [];
		        this.filteredServices = [];
		      }
		    } else {		       
		        this.filterServices();
 		        //Trying to the extend serviceName..
		        //The filtered service list is not changed here.
		        //But only if there is a filteredServicesList and if the user wasn't deleting characters
		        //event.keyCode 46 = delete
		        //event.keyCode  8 = backspace
		        iw.log("Event key code: " + event.keyCode, 3);
		        if(this.filteredServices.length > 0 && this.serviceName && this.serviceName.length > 2 && (event.keyCode != 46 && event.keyCode != 8)) {
                iw.log("Extending the service name...", 3);
                this.serviceName = iw.findLongestCommonString(this.serviceName, this.filteredServices.map(function(el){return el.nsname }));
                if(this.filteredServices.length == 1) {
                  this.serviceName = this.filteredServices[0].nsname;
                  this.selected = true;
                  this.$emit('service-selected', this.serviceName);    
                }
		        }
		        //end smart extension of the service name
		    }
		  },
		  
		  filterServices : function () {
         iw.log("Filtering service list", 3);  
		     if(this.serviceName) {
     		    let s = this.serviceName.toLowerCase();
 		        iw.log("service name part: " + s, 4);
		      	this.filteredServices = this.services.filter(function(a){
              let result = false;
              if (a.nsname.toLowerCase().includes(s)) {
                result = true;
              } 
              iw.log(a.nsname + " qualifies? " + result, 4);
		          return result
		        });
		      } else {
		        this.filteredServices = this.services;
		      }
		    this.servicesText = this.filteredServices.map(function(s){return s.nsname}).join("\n");
        if(this.servicesText.length == 0) {
           this.servicesText = "<no matching services>";
        }  
		  },
		     
      selectService : function(event) {
		    //Capture the selected text. When we get here, the user has clicked in the
		    //textarea with services. Copy the service name to the main text field.
          //We need to do some string manipulation. From the cursor position in the 
          //textarea we deduce the who line = service name
 		    if(document.getSelection) {
              
              var ta = document.getElementById("service-list-area");
              var s = ta.value.substring(ta.selectionStart, ta.selectionEnd);
              var start = ta.value.lastIndexOf("\n", ta.selectionStart) + 1;  //exclude the new line from the selection
              var end = ta.value.indexOf("\n", ta.selectionStart); 
              if(end < 0) {
                  end = ta.value.length;
              } else if(ta.value.indexOf("\r", ta.selectionStart) > 0 && ta.value.indexOf("\r", ta.selectionStart) < end) {
                  end = ta.value.indexOf("\r", ta.selectionStart);
              }
              var selectedService = ta.value.substring(start, end);
              this.serviceName = selectedService;
              this.selected = true;
              this.$emit('service-selected', selectedService);
              iw.log("Computed: '" + ta.value.substring(start, end) + "' start: " + start + "; end: "+ end, 3);
           } else {
              selectedService = window.getSelection().toString()
              if(selectedService.length > 2 ) {
           }     		        		
		        
		    }
		},
      
    },
  });
        
})(this, undefined);