
(function(window, undefined) {
        
  iw.config = new Vue({
    el: '#config-app',
      data : {
        message: "",
        success: true,
        aliases: [],
        agents: [],
        serverAliases: [],
        //availableAliases: [],
        alias: "",
        config: {},    
        dirty: false,
        aliasSelected: false
      },
      computed: {
        availableAliases : function() {
            var difference = [];
            var found = false
            
            for (i = 0 ; i < this.serverAliases.length ; i++) {
               found = false;
               
               for (j = 0 ; j < this.aliases.length ; j++ ) {
            
                   if(this.aliases[j] === this.serverAliases[i] ) {                   
                       found = true;            
                       break;
                   }
               }
               if(!found && this.serverAliases[i].indexOf("local") < 0 ) {
                   difference.push(iw.config.serverAliases[i]);
               }
            }        
          return difference;
        }      
      },
      
      methods : {
       
        response :function(data) {
          //console.log("Logging response from IS");
          //console.log(data);
          iw.config.showMessage(data["$message"], data["$success"], 5000);
          iw.config.success = data["$success"] === "true" ? true : false;
          iw.config.getConfiguration();
        },
        
        showMessage : function(msg, success, timeout) {  
          if(msg) iw.config.message = msg;
          iw.config.success = success;
          if(typeof(timeout) === "number") {
             setTimeout(function(){iw.config.message=""}, timeout);
          }
        },
       
        hideMessage : function() {
           iw.config.message = "";
        },        

        getConfiguration  : function() {
          iw.invoke("iw.test.config:get", {}, function(data) {
            
             iw.config.config = data;
             iw.config.dirty = false;
             
             iw.config.listServerAliases();     
             iw.log("Configuration loaded", 3)
                        
          });
          iw.invoke("iw.test.ui.config:get", {}, function(data){
            iw.config.agents = data.agents;
            iw.log("Agent Configuration loaded", 3)
          
          });
        }, 
		
        saveConfiguration : function() {
            iw.invoke("iw.test.config:set", iw.config.config, iw.config.response);
            iw.config.dirty = false;
        },
    
        listAliases: function() {
            iw.invoke("iw.test.alias:list", {}, function(data) {
              iw.config.aliases = data.aliases;   
            });
        },
    
        addAlias: function(alias) {
            if(alias !== "" ) {
               iw.invoke("iw.test.alias:add", {"alias": alias}, iw.config.response);
            }
            iw.config.alias = "";
        },
    
        removeAlias: function(al) {
            iw.invoke("iw.test.alias:remove", {"alias": al}, iw.config.response);        
        },		
    
        listServerAliases: function() {
              iw.invoke("wm.server.remote:getServerAliases", {}, function(data) {
                  iw.config.serverAliases = data.servers;              
              
                  iw.config.listAliases();
                }); 
        }, 
        
        updateCentralAlias: function (centralAlias, remoteAlias) {
          var param = {"$alias" : remoteAlias, "central.alias" : centralAlias}
          iw.invoke("iw.test.ui.config:set", param, iw.config.response);
        },
				
        nonAlphaNumsToUnderscores : function(text) {
           // \W matches all non-alphanumeric. Equivalent to [^A-Za-z0-9_]
           return text.replace(/[\W]+/g, '_');
        }
      }
      
    });
   
   iw.config.getConfiguration();

})(this, undefined);


