
(function(window, undefined) {   
   
   iw.results = new Vue({
      el: '#results-app',
      data : {
        license                 : {
            product             : "IwTest",
            version             : "1.*",
            licensee            : "",
            type                : "",
            "valid-until"       : "",
            "valid-until-ts"    : -1,
            valid               : true,
            expired             : false,
            "version-ok"        : true,
            "days-left"         : -1
         },
        date: "",
        results: {},        
        pipelinePopup: null,
        success: true,
        message: ""
      },
      methods : {
      
    //Use this function for showing the result of actions, not for data retrieval
      response :function(data) {
         iw.log("Logging response from IS", 4);
         iw.log(JSON.stringify(data), 4);
         iw.results.showMessage(data["$message"], data["$success"] === "true" , 2500);        
         iw.results.getTestResults();
      },
    
      error : function(msg) { 
        iw.log(msg, 0);
        iw.results.showMessage(msg, false , 2500);       
      },   
      showMessage : function(msg, success, timeout) {  
        iw.results.message = msg;
        iw.results.success = success;
        if(typeof(timeout) === "number") {
          setTimeout(function(){iw.results.message=""}, timeout);
        }
      },
      hideMessage : function() {
         iw.record.message = "";
      },        
      info : function() {
        iw.invoke("iw.test.admin:info", {}, function(data) {
          iw.results.license = data.license;
        });
      },         
        getTestResults   : function() {
          iw.invoke("iw.test.results.pub:get", {}, function(data) {
            iw.log("Loading test results ...", 3);
            iw.log(data, 3);
            //Sort the test suites and the test cases within
            if(data.results.testSuites !== undefined) {
                data.results.testSuites.sort(function(a,b){
                  return a.name < b.name ? -1 : 1;
                });
                for(i = 0 ; i < data.results.testSuites.length; i ++) {
                    data.results.testSuites[i].testCases.sort(
                       function(a,b) {           
                           return a.name < b.name ? -1 : 1;
                       }
                    );
                }
            }
            iw.results.results = data.results;
            }, iw.results.error);
        },
        clearTestResults : function() {
          iw.invoke("iw.test.results.pub:clear", {}, function() {
            iw.results.getTestResults();
          }, iw.results.error);
        },         
        failedTestCases : function(testSuite) {
            return testSuite.testCases.filter(
              function(tcase) {
                 return !tcase.result
              }
            )
        },
        nonAlphaNumsToUnderscores : function(text) {
		      // \W matches all non-alphanumeric. Equivalent to [^A-Za-z0-9_]
		      return text.replace(/[\W]+/g, '_');
        },
        setPipelinePopup(data) {
            iw.log("Setting pipeline popup..", 3);
            this.pipelinePopup = data;
        }    
                 
      },
      computed: {
        failedTestSuites: function() {
           return this.results.testSuites.filter(
              function(suite) {
                 return suite.failed > 0
              }
           )
        }		
      }
    });
    

   iw.logResponse = function(data) {
      console.log("Logging response from IS");
      console.log(data);
   };

   iw.results.info();
   iw.results.getTestResults();
    
})(this, undefined);


